DIM D(10500) '(210 x 50)  "1-50 line screen information"
CLS 'clear the screen
COLOR 15, 1
FOR A = 0 TO 50
PRINT ' fill screen with colour first
NEXT A
PORT.B = &H379 'inputs
PORT.A = &H378 'data outputs
OUT PORT.A, &HFF'load all highs into data lines
LOCATE 5, 1
PRINT "                 **************************************"
PRINT "                         Short Circuits II "
PRINT "                      ---LED Display Driver---"
PRINT "                 **************************************"
PRINT
COLOR 12, 1
PRINT "                 MAKE SURE THAT THE COMPUTER DRIVEN LED"
PRINT "           DISPLAY BOARD IS CONNECTED TO THE PARALLEL COMPUTER "
PRINT "                 PORT AND APPLY POWER TO THE CIRCUIT"
COLOR 29, 1
PRINT
PRINT
PRINT "             PRESS THE D KEY TO BEGIN THE DICE PROGRAM"
PRINT
PRINT "             PRESS THE C KEY TO BEGIN THE COUNTER PROGRAM"
PRINT
PRINT "             PRESS THE R KEY TO BEGIN THE RANDOM NUMBER SELECTOR"
PRINT
COLOR 12, 1
1 A$ = INPUT$(1)' get keyboard input
PRINT A$
IF A$ = CHR$(67) THEN GOTO 5' C pressed then counter program
IF A$ = CHR$(68) THEN GOTO 2000' D pressed then dice program
IF A$ = CHR$(99) THEN GOTO 5' c pressed then counter program
IF A$ = CHR$(100) THEN GOTO 2000' d pressed then dice program
IF A$ = CHR$(82) THEN GOTO 3000' R pressed then dice program
IF A$ = CHR$(114) THEN GOTO 3000' r pressed then dice program

GOTO 1
5 CLS
COLOR 12, 1
PRINT "                         COUNTER PROGRAM"
PRINT
PRINT
PRINT "                   PRESS THE SWITCH (S2) TO COUNT"
PRINT "               PRESS ESCAPE (Esc) KEY TO EXIT PROGRAM"
GOSUB 100
200 OUT PORT.A, &H0 'ZERO
PRINT "0 ";
GOSUB 1000
GOSUB 100
OUT PORT.A, &H1 'ONE
PRINT "1 ";
GOSUB 1000
GOSUB 100
OUT PORT.A, &H2 'TWO
PRINT "2 ";
GOSUB 1000
GOSUB 100
OUT PORT.A, &H3 'THREE
PRINT "3 ";
GOSUB 1000
GOSUB 100
OUT PORT.A, &H4 'FOUR
PRINT "4 ";
GOSUB 1000
GOSUB 100
OUT PORT.A, &H5 'FIVE
PRINT "5 ";
GOSUB 1000
GOSUB 100
OUT PORT.A, &H6 'SIX
PRINT "6 ";
GOSUB 1000
GOSUB 100
OUT PORT.A, &H7 'SEVEN
PRINT "7 ";
GOSUB 1000
GOSUB 100
OUT PORT.A, &H8 'EIGHT
PRINT "8 ";
GOSUB 1000
GOSUB 100
OUT PORT.A, &H9 'NINE
PRINT "9 "
GOSUB 1000
GOSUB 100
GOTO 200

'*************************************************
'SUBROUTINES FOR TIMING AND READING S2.

1000 Z = TIMER
12 Y = TIMER
IF Y > Z + 1 THEN GOTO 13 'ONE SECOND
GOTO 12
13 RETURN

100 IF INKEY$ = CHR$(27) THEN GOTO 50'END OF PROGRAM
E = INP(PORT.B) 'check if S2 closed
F = &HEF OR E 'single out D4
IF F = &HFF GOTO 100 'switch open
RETURN
'**********************************************************
2000 CLS
PRINT "                      DICE PROGRAM"
PRINT
PRINT
PRINT "               PRESS SWITCH (S2) TO SELECT A NUMBER"
PRINT "               PRESS ESCAPE (Esc) KEY TO EXIT PROGRAM"
RANDOMIZE TIMER 'initialise random number using timer
3 GOSUB 1000
GOSUB 100
4 A = RND
A = A * 10 'process random number from .xxx to x.xx
C = FIX(A)' get number before decimal point
IF C = 0 THEN GOTO 4' zero not on dice
IF C > 6 THEN GOTO 4' numbers greater than 6 not allowed
PRINT C;
OUT PORT.A, C' number to display
GOTO 3
'******************************************************
3000 CLS
PRINT "                      RANDOM NUMBER PROGRAM"
PRINT
PRINT
PRINT "               PRESS SWITCH (S2) TO SELECT A NUMBER"
PRINT "               PRESS ESCAPE (Esc) KEY TO EXIT PROGRAM"
RANDOMIZE TIMER 'initialise random number using timer
7 GOSUB 1000
GOSUB 100
A = RND
A = A * 10 'process random number from .xxx to x.xx
C = FIX(A)' get number before decimal point
PRINT C;
OUT PORT.A, C' number to display
GOTO 7

'************************************************************
50 END

